--- /dev/null	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/lctype.h	Tue May 20 07:58:47 2014
@@ -0,0 +1,66 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
+
+#ifndef	_LCTYPE_H_
+#define	_LCTYPE_H_
+
+#include <wchar.h>
+
+/* private LC_CTYPE related structures */
+
+/* encoding callbacks */
+struct lc_ctype {
+
+	size_t (*lc_mbrtowc)(wchar_t *_RESTRICT_KYWD,
+	    const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD);
+
+	int (*lc_mbsinit)(const mbstate_t *);
+
+	size_t (*lc_mbsnrtowcs)(wchar_t *_RESTRICT_KYWD,
+	    const char **_RESTRICT_KYWD, size_t, size_t,
+	    mbstate_t *_RESTRICT_KYWD);
+
+	size_t (*lc_wcrtomb)(char *_RESTRICT_KYWD, wchar_t,
+	    mbstate_t *_RESTRICT_KYWD);
+
+	size_t (*lc_wcsnrtombs)(char *_RESTRICT_KYWD,
+	    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+	    mbstate_t *_RESTRICT_KYWD);
+
+	unsigned char lc_is_ascii;
+	unsigned char lc_max_mblen;
+
+	const int *lc_trans_upper;
+	const int *lc_trans_lower;
+	const unsigned *lc_ctype_mask;
+};
+
+/*
+ * Default implementation (C locale, i.e. ASCII).
+ */
+size_t	__mbrtowc_ascii(wchar_t *_RESTRICT_KYWD,
+    const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD);
+int	__mbsinit_ascii(const mbstate_t *);
+size_t	__mbsnrtowcs_ascii(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src, size_t nms, size_t len,
+    mbstate_t *_RESTRICT_KYWD);
+size_t	__wcrtomb_ascii(char *_RESTRICT_KYWD, wchar_t,
+    mbstate_t *_RESTRICT_KYWD);
+size_t	__wcsnrtombs_ascii(char *_RESTRICT_KYWD,
+    const wchar_t **_RESTRICT_KYWD,
+    size_t, size_t, mbstate_t *_RESTRICT_KYWD);
+
+
+#endif /* !_LCTYPE_H_ */
--- old/usr/src/lib/libc/port/locale/ldpart.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/ldpart.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
@@ -43,7 +44,7 @@
 static int split_lines(char *, const char *);
 
 int
-__part_load_locale(const char *name, int *using_locale,
+__part_load_locale(const char *name,
     char **locale_buf, const char *category_filename,
     int locale_buf_size_max, int locale_buf_size_min,
     const char **dst_localebuf)
@@ -55,21 +56,7 @@
 	struct stat	st;
 	size_t		namesize, bufsize;
 
-	/* 'name' must be already checked. */
-	if (strcmp(name, "C") == 0 || strcmp(name, "POSIX") == 0) {
-		*using_locale = 0;
-		return (_LDP_CACHE);
-	}
-
 	/*
-	 * If the locale name is the same as our cache, use the cache.
-	 */
-	if (*locale_buf != NULL && strcmp(name, *locale_buf) == 0) {
-		*using_locale = 1;
-		return (_LDP_CACHE);
-	}
-
-	/*
 	 * Slurp the locale file into the cache.
 	 */
 	namesize = strlen(name) + 1;
@@ -117,14 +104,11 @@
 	/*
 	 * Record the successful parse in the cache.
 	 */
-	if (*locale_buf != NULL)
-		free(*locale_buf);
 	*locale_buf = lbuf;
 	for (p = *locale_buf, i = 0; i < num_lines; i++)
 		dst_localebuf[i] = (p += strlen(p) + 1);
 	for (i = num_lines; i < locale_buf_size_max; i++)
 		dst_localebuf[i] = NULL;
-	*using_locale = 1;
 
 	return (_LDP_LOADED);
 
--- old/usr/src/lib/libc/port/locale/ldpart.h	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/ldpart.h	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
  *
@@ -31,7 +32,7 @@
 #define	_LDP_ERROR  (-1)
 #define	_LDP_CACHE  1
 
-int	__part_load_locale(const char *, int *, char **, const char *,
+int	__part_load_locale(const char *, char **, const char *,
 		    int, int, const char **);
 
 #endif /* !_LDPART_H_ */
--- old/usr/src/lib/libc/port/locale/lmessages.c	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/lmessages.c	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
@@ -27,16 +28,18 @@
 
 #include "lint.h"
 #include <stddef.h>
+#include <errno.h>
 #include "ldpart.h"
 #include "lmessages.h"
+#include "localeimpl.h"
 
-#define	LCMESSAGES_SIZE_FULL (sizeof (struct lc_messages_T) / sizeof (char *))
+#define	LCMESSAGES_SIZE_FULL (sizeof (struct lc_messages) / sizeof (char *))
 #define	LCMESSAGES_SIZE_MIN \
-	(offsetof(struct lc_messages_T, yesstr) / sizeof (char *))
+	(offsetof(struct lc_messages, yesstr) / sizeof (char *))
 
 static char empty[] = "";
 
-static const struct lc_messages_T _C_messages_locale = {
+struct lc_messages lc_messages_posix = {
 	"^[yY]",	/* yesexpr */
 	"^[nN]",	/* noexpr */
 	"yes",		/* yesstr */
@@ -43,31 +46,37 @@
 	"no"		/* nostr */
 };
 
-static struct lc_messages_T _messages_locale;
-static int	_messages_using_locale;
-static char	*_messages_locale_buf;
+struct locdata __posix_messages_locdata = {
+	.l_lname = "C",
+	.l_refcnt = (uint32_t)-1,
+	.l_data = { &lc_messages_posix }
+};
 
-int
-__messages_load_locale(const char *name)
+struct locdata *
+__lc_messages_load(const char *name)
 {
+	struct locdata *ldata;
+	struct lc_messages *lmsgs;
 	int ret;
 
-	ret = __part_load_locale(name, &_messages_using_locale,
-	    &_messages_locale_buf, "LC_MESSAGES",
-	    LCMESSAGES_SIZE_FULL, LCMESSAGES_SIZE_MIN,
-	    (const char **)&_messages_locale);
-	if (ret == _LDP_LOADED) {
-		if (_messages_locale.yesstr == NULL)
-			_messages_locale.yesstr = empty;
-		if (_messages_locale.nostr == NULL)
-			_messages_locale.nostr = empty;
+	if ((ldata = __locdata_alloc(name, sizeof (*lmsgs))) == NULL)
+		return (NULL);
+	lmsgs = ldata->l_data[0];
+
+	ret = __part_load_locale(name, (char **)&ldata->l_data[1],
+	    "LC_MESSAGES", LCMESSAGES_SIZE_FULL, LCMESSAGES_SIZE_MIN,
+	    (const char **)lmsgs);
+
+	if (ret != _LDP_LOADED) {
+		__locdata_release(ldata);
+		errno = EINVAL;
+		return (NULL);
 	}
-	return (ret);
-}
 
-struct lc_messages_T *
-__get_current_messages_locale(void)
-{
-	return (_messages_using_locale ? &_messages_locale :
-	    (struct lc_messages_T *)&_C_messages_locale);
+	if (lmsgs->yesstr == NULL)
+		lmsgs->yesstr = empty;
+	if (lmsgs->nostr == NULL)
+		lmsgs->nostr = empty;
+
+	return (ldata);
 }
--- old/usr/src/lib/libc/port/locale/lmessages.h	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/lmessages.h	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
  *
@@ -27,7 +28,7 @@
 #ifndef _LMESSAGES_H_
 #define	_LMESSAGES_H_
 
-struct	lc_messages_T {
+struct	lc_messages {
 	const char	*yesexpr;
 	const char	*noexpr;
 	const char	*yesstr;
@@ -34,7 +35,4 @@
 	const char	*nostr;
 };
 
-struct lc_messages_T *__get_current_messages_locale(void);
-int	__messages_load_locale(const char *);
-
 #endif /* !_LMESSAGES_H_ */
--- old/usr/src/lib/libc/port/locale/lmonetary.c	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/lmonetary.c	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
@@ -29,20 +30,23 @@
 #include <limits.h>
 #include <stddef.h>
 #include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
 #include "ldpart.h"
 #include "lmonetary.h"
+#include "localeimpl.h"
 
-extern int __mlocale_changed;
 extern const char *__fix_locale_grouping_str(const char *);
 
-#define	LCMONETARY_SIZE_FULL (sizeof (struct lc_monetary_T) / sizeof (char *))
+#define	LCMONETARY_SIZE_FULL (sizeof (struct lc_monetary) / sizeof (char *))
 #define	LCMONETARY_SIZE_MIN \
-	(offsetof(struct lc_monetary_T, int_p_cs_precedes) / sizeof (char *))
+	(offsetof(struct lc_monetary, int_p_cs_precedes) / sizeof (char *))
 
 static char	empty[] = "";
 static char	numempty[] = { CHAR_MAX, '\0' };
 
-static const struct lc_monetary_T _C_monetary_locale = {
+struct lc_monetary lc_monetary_posix = {
 	empty,		/* int_curr_symbol */
 	empty,		/* currency_symbol */
 	empty,		/* mon_decimal_point */
@@ -63,12 +67,15 @@
 	numempty,	/* int_p_sep_by_space */
 	numempty,	/* int_n_sep_by_space */
 	numempty,	/* int_p_sign_posn */
-	numempty	/* int_n_sign_posn */
+	numempty,	/* int_n_sign_posn */
+	empty		/* crncystr */
 };
 
-static struct lc_monetary_T _monetary_locale;
-static int	_monetary_using_locale;
-static char	*_monetary_locale_buf;
+struct locdata __posix_monetary_locdata = {
+	.l_lname = "C",
+	.l_refcnt = (uint32_t)-1,
+	.l_data = { &lc_monetary_posix }
+};
 
 static char
 cnv(const char *str)
@@ -80,59 +87,94 @@
 	return ((char)i);
 }
 
-int
-__monetary_load_locale(const char *name)
+struct locdata *
+__lc_monetary_load(const char *name)
 {
 	int ret;
+	int clen;
+	struct lc_monetary	*lmon;
+	struct locdata		*ldata;
 
-	ret = __part_load_locale(name, &_monetary_using_locale,
-	    &_monetary_locale_buf, "LC_MONETARY",
-	    LCMONETARY_SIZE_FULL, LCMONETARY_SIZE_MIN,
-	    (const char **)&_monetary_locale);
-	if (ret != _LDP_ERROR)
-		__mlocale_changed = 1;
-	if (ret == _LDP_LOADED) {
-		_monetary_locale.mon_grouping =
-		    __fix_locale_grouping_str(_monetary_locale.mon_grouping);
+	if ((ldata = __locdata_alloc(name, sizeof (*lmon))) == NULL) {
+		return (NULL);
+	}
+	lmon = ldata->l_data[0];
 
+	ret = __part_load_locale(name, (char **)&ldata->l_data[1],
+	    "LC_MONETARY", LCMONETARY_SIZE_FULL, LCMONETARY_SIZE_MIN,
+	    (const char **)lmon);
+
+	if (ret != _LDP_LOADED) {
+		__locdata_release(ldata);
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	/* special storage for currency string */
+	clen = strlen(lmon->currency_symbol) + 2;
+	ldata->l_data[2] = malloc(clen);
+	lmon->crncystr = ldata->l_data[2];
+	lmon->crncystr[0] = '\0';
+
+	lmon->mon_grouping = __fix_locale_grouping_str(lmon->mon_grouping);
+
 #define	M_ASSIGN_CHAR(NAME) \
-		(((char *)_monetary_locale.NAME)[0] = \
-			cnv(_monetary_locale.NAME))
+	(((char *)lmon->NAME)[0] = cnv(lmon->NAME))
 
-		M_ASSIGN_CHAR(int_frac_digits);
-		M_ASSIGN_CHAR(frac_digits);
-		M_ASSIGN_CHAR(p_cs_precedes);
-		M_ASSIGN_CHAR(p_sep_by_space);
-		M_ASSIGN_CHAR(n_cs_precedes);
-		M_ASSIGN_CHAR(n_sep_by_space);
-		M_ASSIGN_CHAR(p_sign_posn);
-		M_ASSIGN_CHAR(n_sign_posn);
+	M_ASSIGN_CHAR(int_frac_digits);
+	M_ASSIGN_CHAR(frac_digits);
+	M_ASSIGN_CHAR(p_cs_precedes);
+	M_ASSIGN_CHAR(p_sep_by_space);
+	M_ASSIGN_CHAR(n_cs_precedes);
+	M_ASSIGN_CHAR(n_sep_by_space);
+	M_ASSIGN_CHAR(p_sign_posn);
+	M_ASSIGN_CHAR(n_sign_posn);
 
-		/*
-		 * The six additional C99 international monetary formatting
-		 * parameters default to the national parameters when
-		 * reading FreeBSD LC_MONETARY data files.
-		 */
-#define	M_ASSIGN_ICHAR(NAME)					\
-		if (_monetary_locale.int_##NAME == NULL)	\
-			_monetary_locale.int_##NAME =		\
-			    _monetary_locale.NAME;		\
-		else						\
-			M_ASSIGN_CHAR(int_##NAME);
+	/*
+	 * The six additional C99 international monetary formatting
+	 * parameters default to the national parameters when
+	 * reading FreeBSD LC_MONETARY data files.
+	 */
+#define	M_ASSIGN_ICHAR(NAME)				\
+	if (lmon->int_##NAME == NULL)			\
+		lmon->int_##NAME = lmon->NAME;		\
+	else						\
+		M_ASSIGN_CHAR(int_##NAME);
 
-		M_ASSIGN_ICHAR(p_cs_precedes);
-		M_ASSIGN_ICHAR(n_cs_precedes);
-		M_ASSIGN_ICHAR(p_sep_by_space);
-		M_ASSIGN_ICHAR(n_sep_by_space);
-		M_ASSIGN_ICHAR(p_sign_posn);
-		M_ASSIGN_ICHAR(n_sign_posn);
+	M_ASSIGN_ICHAR(p_cs_precedes);
+	M_ASSIGN_ICHAR(n_cs_precedes);
+	M_ASSIGN_ICHAR(p_sep_by_space);
+	M_ASSIGN_ICHAR(n_sep_by_space);
+	M_ASSIGN_ICHAR(p_sign_posn);
+	M_ASSIGN_ICHAR(n_sign_posn);
+
+	/*
+	 * Now calculate the currency string (CRNCYSTR) for nl_langinfo.
+	 * This is a legacy SUSv2 interface.
+	 */
+	if ((lmon->p_cs_precedes[0] == lmon->n_cs_precedes[0]) &&
+	    (lmon->currency_symbol[0] != '\0')) {
+		char sign = '\0';
+		switch (lmon->p_cs_precedes[0]) {
+		case 0:
+			sign = '-';
+			break;
+		case 1:
+			sign = '+';
+			break;
+		case CHAR_MAX:
+			/*
+			 * Substitute currency string for radix character.
+			 * To the best of my knowledge, no locale uses this.
+			 */
+			if (strcmp(lmon->mon_decimal_point,
+			    lmon->currency_symbol) == 0)
+				sign = '.';
+			break;
+		}
+		(void) snprintf(lmon->crncystr, clen, "%c%s", sign,
+		    lmon->currency_symbol);
 	}
-	return (ret);
-}
 
-struct lc_monetary_T *
-__get_current_monetary_locale(void)
-{
-	return (_monetary_using_locale ? &_monetary_locale :
-	    (struct lc_monetary_T *)&_C_monetary_locale);
+	return (ldata);
 }
--- old/usr/src/lib/libc/port/locale/lmonetary.h	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/lmonetary.h	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
  *
@@ -27,7 +28,7 @@
 #ifndef _LMONETARY_H_
 #define	_LMONETARY_H_
 
-struct lc_monetary_T {
+struct lc_monetary {
 	const char	*int_curr_symbol;
 	const char	*currency_symbol;
 	const char	*mon_decimal_point;
@@ -49,9 +50,9 @@
 	const char	*int_n_sep_by_space;
 	const char	*int_p_sign_posn;
 	const char	*int_n_sign_posn;
+	char		*crncystr;		/* nl_langinfo */
 };
 
-struct lc_monetary_T *__get_current_monetary_locale(void);
 int	__monetary_load_locale(const char *);
 
 #endif /* !_LMONETARY_H_ */
--- old/usr/src/lib/libc/port/locale/lnumeric.c	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/lnumeric.c	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore.
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
@@ -27,59 +28,59 @@
 
 #include "lint.h"
 #include <limits.h>
+#include <errno.h>
 #include "ldpart.h"
 #include "lnumeric.h"
-#include "../i18n/_locale.h"
+#include "localeimpl.h"
 
-extern int __nlocale_changed;
 extern const char *__fix_locale_grouping_str(const char *);
 
-#define	LCNUMERIC_SIZE (sizeof (struct lc_numeric_T) / sizeof (char *))
+#define	LCNUMERIC_SIZE (sizeof (struct lc_numeric) / sizeof (char *))
 
 static char	numempty[] = { CHAR_MAX, '\0' };
 
-static const struct lc_numeric_T _C_numeric_locale = {
+struct lc_numeric lc_numeric_posix = {
 	".",		/* decimal_point */
 	"",		/* thousands_sep */
 	numempty	/* grouping */
 };
 
-static struct lc_numeric_T _numeric_locale;
-static int	_numeric_using_locale;
-static char	*_numeric_locale_buf;
+struct locdata __posix_numeric_locdata = {
+	.l_lname = "C",
+	.l_refcnt = (uint32_t)-1,
+	.l_data = { &lc_numeric_posix }
+};
 
-int
-__numeric_load_locale(const char *name)
-{
-	const struct lc_numeric_T *leg = &_C_numeric_locale;
 
+/*
+ * Return the locale's numeric locdata structure, places a hold on it,
+ * which the caller must release.
+ */
+struct locdata *
+__lc_numeric_load(const char *name)
+{
+	struct locdata *ldata;
+	struct lc_numeric *lnum;
 	int ret;
 
-	ret = __part_load_locale(name, &_numeric_using_locale,
-	    &_numeric_locale_buf, "LC_NUMERIC", LCNUMERIC_SIZE, LCNUMERIC_SIZE,
-	    (const char **)&_numeric_locale);
-	if (ret == _LDP_ERROR)
-		return (_LDP_ERROR);
+	if ((ldata = __locdata_alloc(name, sizeof (*lnum))) == NULL) {
+		errno = EINVAL;
+		return (NULL);
+	}
+	lnum = ldata->l_data[0];
 
-	__nlocale_changed = 1;
-	if (ret == _LDP_LOADED) {
-		/* Can't be empty according to C99 */
-		if (*_numeric_locale.decimal_point == '\0')
-			_numeric_locale.decimal_point =
-			    _C_numeric_locale.decimal_point;
-		_numeric_locale.grouping =
-		    __fix_locale_grouping_str(_numeric_locale.grouping);
-		leg = (const struct lc_numeric_T *)&_numeric_locale;
+	ret = __part_load_locale(name, (char **)&ldata->l_data[1],
+	    "LC_NUMERIC", LCNUMERIC_SIZE, LCNUMERIC_SIZE, (const char **)lnum);
+
+	if (ret != _LDP_LOADED) {
+		__locdata_release(ldata);
+		return (NULL);
 	}
-	/* This is Solaris legacy, required for ABI compatability */
-	_numeric[0] = *leg->decimal_point;
-	_numeric[1] = *leg->grouping;
-	return (ret);
-}
 
-struct lc_numeric_T *
-__get_current_numeric_locale(void)
-{
-	return (_numeric_using_locale ? &_numeric_locale :
-	    (struct lc_numeric_T *)&_C_numeric_locale);
+	/* Can't be empty according to C99 */
+	if (*lnum->decimal_point == '\0')
+		lnum->decimal_point = lc_numeric_posix.decimal_point;
+	lnum->grouping = __fix_locale_grouping_str(lnum->grouping);
+
+	return (ldata);
 }
--- old/usr/src/lib/libc/port/locale/lnumeric.h	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/lnumeric.h	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2000, 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
  *
@@ -27,13 +28,10 @@
 #ifndef _LNUMERIC_H_
 #define	_LNUMERIC_H_
 
-struct lc_numeric_T {
+struct lc_numeric {
 	const char	*decimal_point;
 	const char	*thousands_sep;
 	const char	*grouping;
 };
 
-struct lc_numeric_T *__get_current_numeric_locale(void);
-int	__numeric_load_locale(const char *);
-
 #endif /* !_LNUMERIC_H_ */
--- old/usr/src/lib/libc/port/locale/localeconv.c	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/localeconv.c	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * Copyright (c) 1991, 1993
@@ -37,35 +38,37 @@
 #include <locale.h>
 #include "lmonetary.h"
 #include "lnumeric.h"
+#include "localeimpl.h"
 
 /*
- * The localeconv() function constructs a struct lconv from the current
- * monetary and numeric locales.
+ * Return the current locale conversion.
  *
+ * Note that XPG7 specifically states that localeconv's return value may
+ * be invalidated if the application calls setlocale() or uselocale() within
+ * the same thread.
+ *
  * Because localeconv() may be called many times (especially by library
  * routines like printf() & strtod()), the approprate members of the
  * lconv structure are computed only when the monetary or numeric
  * locale has been changed.
  */
-int __mlocale_changed = 1;
-int __nlocale_changed = 1;
-
-/*
- * Return the current locale conversion.
- */
 struct lconv *
 localeconv(void)
 {
-	static struct lconv ret;
+	struct lconv	*lconv;
+	locale_t	loc;
+	struct lc_monetary	*mptr;
+	struct lc_numeric	*nptr;
 
-	if (__mlocale_changed) {
-		/* LC_MONETARY part */
-		struct lc_monetary_T *mptr;
+	loc = uselocale(NULL);
+	lconv = &loc->lconv;
 
-#define	M_ASSIGN_STR(NAME) (ret.NAME = (char *)mptr->NAME)
-#define	M_ASSIGN_CHAR(NAME) (ret.NAME = mptr->NAME[0])
+	if (loc->loaded[LC_MONETARY] == 0) {
+		mptr = loc->locdata[LC_MONETARY]->l_data[0];
 
-		mptr = __get_current_monetary_locale();
+#define	M_ASSIGN_STR(NAME) (lconv->NAME = (char *)mptr->NAME)
+#define	M_ASSIGN_CHAR(NAME) (lconv->NAME = mptr->NAME[0])
+
 		M_ASSIGN_STR(int_curr_symbol);
 		M_ASSIGN_STR(currency_symbol);
 		M_ASSIGN_STR(mon_decimal_point);
@@ -87,21 +90,19 @@
 		M_ASSIGN_CHAR(int_n_sep_by_space);
 		M_ASSIGN_CHAR(int_p_sign_posn);
 		M_ASSIGN_CHAR(int_n_sign_posn);
-		__mlocale_changed = 0;
+		loc->loaded[LC_MONETARY] = 1;
 	}
 
-	if (__nlocale_changed) {
-		/* LC_NUMERIC part */
-		struct lc_numeric_T *nptr;
+	if (loc->loaded[LC_NUMERIC] == 0) {
+		nptr = loc->locdata[LC_NUMERIC]->l_data[0];
 
-#define	N_ASSIGN_STR(NAME) (ret.NAME = (char *)nptr->NAME)
+#define	N_ASSIGN_STR(NAME) (lconv->NAME = (char *)nptr->NAME)
 
-		nptr = __get_current_numeric_locale();
 		N_ASSIGN_STR(decimal_point);
 		N_ASSIGN_STR(thousands_sep);
 		N_ASSIGN_STR(grouping);
-		__nlocale_changed = 0;
+		loc->loaded[LC_NUMERIC] = 1;
 	}
 
-	return (&ret);
+	return (lconv);
 }
